#ifndef DUCHAMP_PREPROCESS_ATROUS_H_
#define DUCHAMP_PREPROCESS_ATROUS_H_

namespace duchamp
{

    class AtrousReconstructor : public Preprocessor
    {
    public:
	AtrousReconstructor();
	AtrousReconstructor(Param &par);
	AtrousReconstructor(const AtrousReconstructor& other);
	AtrousReconstructor& operator= (const AtrousReconstructor& other);
	virtual ~AtrousReconstructor();

	AstroImage<float> recon(){output();};

	virtual void initialise()=0;
	virtual void process()=0;


    protected:
	float itsSNRrecon;
	unsigned int itsMinScale;
	unsigned int itsMaxScale;
	unsigned int itsNumScales;
	bool  itsFlagSaveWaveletArrays;
    };

}

#endif
